%inequality
% An inequality plotter and integer (x,y) solution visualization app.
% LAST UPDATED by Andy French. January 2016.

function varargout = inequality(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @inequality_OpeningFcn, ...
    'gui_OutputFcn',  @inequality_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%

function inequality_OpeningFcn(hObject, eventdata, handles, varargin)
global d

% Choose default command line output for inequality
handles.output = hObject;

% Update handles structure and store this in global array d
guidata(hObject, handles);

%Load GUI data from previous session
try
    load settings
catch
    inequality_defaults;
    load settings
end

%Store GUI handles into array d
d.h = handles; clear handles;

%Centre figure within screen
figcentre( d.h.FIGUREinequality );

%Update the GUI with settings data
set( d.h.EDITineqa1,'string',d.inequalities{1} );
set( d.h.EDITineqa2,'string',d.inequalities{2} );
set( d.h.EDITineqa3,'string',d.inequalities{3} );
set( d.h.EDITineqa4,'string',d.inequalities{4} );
set( d.h.EDITineqa5,'string',d.inequalities{5} );
set( d.h.EDITineqa6,'string',d.inequalities{6} );
set( d.h.EDITineqa7,'string',d.inequalities{7} );
set( d.h.EDITineqa8,'string',d.inequalities{8} );
set( d.h.CHECKineqa1,'value',d.ineqa_show(1) );
set( d.h.CHECKineqa2,'value',d.ineqa_show(2) );
set( d.h.CHECKineqa3,'value',d.ineqa_show(3) );
set( d.h.CHECKineqa4,'value',d.ineqa_show(4) );
set( d.h.CHECKineqa5,'value',d.ineqa_show(5) );
set( d.h.CHECKineqa6,'value',d.ineqa_show(6) );
set( d.h.CHECKineqa7,'value',d.ineqa_show(7) );
set( d.h.CHECKineqa8,'value',d.ineqa_show(8) );
set( d.h.EDITxmin,'string',num2str( d.xmin )) ;
set( d.h.EDITymin,'string',num2str( d.ymin )) ;
set( d.h.EDITxmax,'string',num2str( d.xmax )) ;
set( d.h.EDITymax,'string',num2str( d.ymax )) ;
set( d.h.EDITxtick,'string',num2str( d.xtick )) ;
set( d.h.EDITytick,'string',num2str( d.ytick )) ;
set( d.h.CHECKxyscale,'value',d.xyscale );
set( d.h.EDITxyfunc,'string',d.xyfunc );

%Initialize handle for colorbar object, to enable it to be deleted!
d.colorbar = [];

%Update GUI
gui_update;

%%

%Inequality 1 edit box callback
function EDITineqa1_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 2 edit box callback
function EDITineqa2_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 3 edit box callback
function EDITineqa3_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 4 edit box callback
function EDITineqa4_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 5 edit box callback
function EDITineqa5_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 6 edit box callback
function EDITineqa6_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 7 edit box callback
function EDITineqa7_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 8 edit box callback
function EDITineqa8_Callback(hObject, eventdata, handles)
gui_update

%%


%Inequality 1 check box callback
function CHECKineqa1_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 2 check box callback
function CHECKineqa2_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 3 check box callback
function CHECKineqa3_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 4 check box callback
function CHECKineqa4_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 5 check box callback
function CHECKineqa5_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 6 check box callback
function CHECKineqa6_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 7 check box callback
function CHECKineqa7_Callback(hObject, eventdata, handles)
gui_update

%%

%Inequality 8 check box callback
function CHECKineqa8_Callback(hObject, eventdata, handles)
gui_update

%%

% y axis maximum edit box callback
function EDITymax_Callback(hObject, eventdata, handles)
gui_update

%%

% y axis minimum edit box callback
function EDITymin_Callback(hObject, eventdata, handles)
gui_update

%%

% x axis minimum edit box callback
function EDITxmin_Callback(hObject, eventdata, handles)
gui_update

%%

% x axis maximum edit box callback
function EDITxmax_Callback(hObject, eventdata, handles)
gui_update

%%

% xtick edit box callback
function EDITxtick_Callback(hObject, eventdata, handles)
gui_update

%%

% ytick edit box callback
function EDITytick_Callback(hObject, eventdata, handles)
gui_update

%%

% x,y equal scales checkbox callback
function CHECKxyscale_Callback(hObject, eventdata, handles)
gui_update

%%

% F(x,y) function edit box
function EDITxyfunc_Callback(hObject, eventdata, handles)
global d

%Make sure this cannot be left blank. If it is, default to F = x + y
F = get( d.h.EDITxyfunc,'string' );
if isempty(F)
    set( d.h.EDITxyfunc,'string' ,'x + y');
end

%Update GUI
gui_update

%%

% Print PNG pushbutton
function PUSHprintPNG_Callback(hObject, eventdata, handles)
[fig,ax] = inequality_plotter([]);
print(fig,['plots\inequality ',strrep(datestr(now),':','-')],'-dpng','-r300');
close(fig);

%%

function varargout = inequality_OutputFcn(hObject, eventdata, handles)

%%

% GUI update function
function gui_update
global d

%%% Inputs %%%

%Set number of data points
d.N = 1000;

%Set label font sizes
d.fsize = 20;

%

%Get parameters from GUI
d.inequalities{1} = get( d.h.EDITineqa1,'string' );
d.inequalities{2} = get( d.h.EDITineqa2,'string' );
d.inequalities{3} = get( d.h.EDITineqa3,'string' );
d.inequalities{4} = get( d.h.EDITineqa4,'string' );
d.inequalities{5} = get( d.h.EDITineqa5,'string' );
d.inequalities{6} = get( d.h.EDITineqa6,'string' );
d.inequalities{7} = get( d.h.EDITineqa7,'string' );
d.inequalities{8} = get( d.h.EDITineqa8,'string' );
d.ineqa_show(1) = get( d.h.CHECKineqa1,'value' );
d.ineqa_show(2) = get( d.h.CHECKineqa2,'value' );
d.ineqa_show(3) = get( d.h.CHECKineqa3,'value' );
d.ineqa_show(4) = get( d.h.CHECKineqa4,'value' );
d.ineqa_show(5) = get( d.h.CHECKineqa5,'value' );
d.ineqa_show(6) = get( d.h.CHECKineqa6,'value' );
d.ineqa_show(7) = get( d.h.CHECKineqa7,'value' );
d.ineqa_show(8) = get( d.h.CHECKineqa8,'value' );
d.xmin = str2num( get( d.h.EDITxmin,'string') );
d.ymin = str2num( get( d.h.EDITymin,'string') );
d.xmax = str2num( get( d.h.EDITxmax,'string') );
d.ymax = str2num( get( d.h.EDITymax,'string') );
d.xtick = str2num( get( d.h.EDITxtick,'string') );
d.ytick = str2num( get( d.h.EDITytick,'string') );
d.xyscale = get( d.h.CHECKxyscale,'value' );
d.xyfunc = get( d.h.EDITxyfunc,'string' );

%Plot inequality
[fig,ax] = inequality_plotter(d.h.AXESgraph);

%Save settings
save settings d

%%

%Inequality plotter
function [fig,ax] = inequality_plotter(ax)
global d

%Set the number of points per boundary line plot
N = 500;

%Determine DPI of output PNG file
DPI = 200;

%Maximum number of plots for discrete values within valid region bounded
%via the inequality lines. If this number is exceeded, a smoothly coloured
%region is plotted
Pmax = 500;

%Set tick mark size for graph
ticksize = 1;

%%

%Determine x,y integer arrays
x = floor(d.xmin) : ceil(d.xmax);
y = floor(d.ymin) : ceil(d.ymax);

%Point to axes and clear, or create a new figure and axes
if isempty(ax)
    %Axes doesn't currently exist, so create a new figure first
    fig = figure('name','Inequality plotter');
    ax = axes;
    
    %Make text size a bit smaller for exported figures
    fsize = 12;
else
    fig = d.h.FIGUREinequality;
    axes(ax);
    try
        delete(d.colorbar);
    end
    cla;
    fsize = d.fsize;
end

%Set axes scale and tick marks
set( ax, 'xtick',x(1):ticksize:x(end), 'ytick', y(1):ticksize:y(end),'nextplot','add' );
xlim( [d.xmin,d.xmax] )
ylim( [d.ymin,d.ymax] )
xlabel('x')
ylabel('y')

%Show inequalities?
ineqs = d.inequalities;
for n=1:length(d.inequalities)
    if d.ineqa_show(n)==0
        ineqs{n} = '';
    else
        %Force element-wise multiplication (since x is a vector)
        ineqs{n} = strrep(ineqs{n},'^','.^');
        ineqs{n} = strrep(ineqs{n},'/','./');
        ineqs{n} = strrep(ineqs{n},'*','.*');
        
        %Obtain strings for functions f(x,y) and g(x,y) such that fxy_str is f(x,y) = g(x,y)
        if ~isempty( strfind( ineqs{n}, '>=' ) )
            ineq_str = strfind(ineqs{n},'>');
            f = ineqs{n}(1:ineq_str -1);
            g = ineqs{n}(ineq_str +2:end);
            ineq = ineqs{n}(ineq_str:ineq_str+1);
        elseif ~isempty( strfind( ineqs{n}, '<=' ) )
            ineq_str = strfind(ineqs{n},'<');
            f = ineqs{n}(1:ineq_str -1);
            g = ineqs{n}(ineq_str +2:end);
            ineq = ineqs{n}(ineq_str:ineq_str+1);
        elseif ~isempty( strfind( ineqs{n}, '>' ) )
            ineq_str = strfind(ineqs{n},'>');
            f = ineqs{n}(1:ineq_str -1);
            g = ineqs{n}(ineq_str +1:end);
            ineq = ineqs{n}(ineq_str);
        elseif ~isempty( strfind( ineqs{n}, '<' ) )
            ineq_str = strfind(ineqs{n},'<');
            f = ineqs{n}(1:ineq_str -1);
            g = ineqs{n}(ineq_str +1:end);
            ineq = ineqs{n}(ineq_str);
        end
        
        %Add brackets to inequality to avoid any potential confusion
        %i.e. ( 3*x + 2*y + 1 ) >= ( x.^2 + 2 )
        ineqs{n} = ['(',f,') ',ineq,' (',g,')'];
    end
end

%Obtain inequality boundary functions and define binary vector where 1
%corresponds to a <= or >= and a 0 to a > or an <. The latter will be
%plotted with -- lines, the former solid lines
boundary = ineqs;
solid_line = zeros(1,length(ineqs) );
for n=1:length(ineqs)
    if ~isempty( strfind( boundary{n},'>=' ) )
        solid_line(n) = 1;
    elseif ~isempty( strfind( boundary{n},'<=' ) )
        solid_line(n) = 1;
    end
    boundary{n} = strrep( boundary{n},'>=','=' );
    boundary{n} = strrep( boundary{n},'<=','=' );
    boundary{n} = strrep( boundary{n},'<','=' );
    boundary{n} = strrep( boundary{n},'>','=' );
end

%Determine cell arrays which contain x,y coordinates of boundary lines
xx = cell(1,length(ineqs));
yy = cell(1,length(ineqs));
solid_line = zeros(1,length(ineqs) );
for n=1:length(ineqs)
    [xx{n},yy{n},solid_line(n)] = boundaries( ineqs{n},d.xmin,d.xmax,d.ymin,d.ymax,N);
end

%Compose logical statement which defines x,y subset that satisfies the
%provided inequalities
ineqs_logic_str = [];
for n=1:length(ineqs)
    if ~isempty( ineqs{n} )
        ineqs_logic_str = [ineqs_logic_str,'(',ineqs{n},') & '];
    end
end

%Generate inequality plot unless there are no logical statements (i.e. none of the inequality check
%boxes have been ticked, or none of the inequality edit boxes contain
%anything!)
if ~isempty(ineqs_logic_str)
    
    %Remove last ' & ' from logic string
    ineqs_logic_str( end-2 : end ) = '';
    
    %Make x,y arrays of integer values
    [x,y] = meshgrid(x,y);
    
    %Determine subset of x,y which are valid
    eval( ['ok = ',ineqs_logic_str,';']);
    
    %NaN elements of x,y which have ok=0
    x( ok==0 ) = NaN;
    y( ok==0 ) = NaN;
    
    %Determine xy function F, making sure it can be evaluated
    %elementwise for vector inputs
    xyf = d.xyfunc;
    xyf = strrep( xyf,'*','.*' );
    xyf = strrep( xyf,'/','./' );
    xyf = strrep( xyf,'^','.^' );
    
    %Evaluate xyfunc and find maximum and minimum values
    eval( ['F=',xyf,';'] );
    minF = min(min(F));
    maxF = max(max(F));
    
    %Set colour scale to correspond to maximum and minimum values of F
    if (minF < maxF ) && (~isnan(minF))
        caxis( [minF,maxF] );
    end
    
    %Determine x,y pairs corresponding to maximum and minimum values of F
    imin = find( F==minF );
    imax = find( F==maxF );
    xmin = x(imin);
    xmax = x(imax);
    ymin = y(imin);
    ymax = y(imax);
    
    %Plot default grey patch over everything
    set( ax , 'color' , 0.9*[1,1,1] );
    
    %Determine white area which is valid
    [xw,yw] = meshgrid( linspace(d.xmin,d.xmax,N), linspace(d.ymin,d.ymax,N) );
    ineqs_logic_str = strrep( ineqs_logic_str, 'x','xw');
    ineqs_logic_str = strrep( ineqs_logic_str, 'y','yw');
    eval( ['ok = ',ineqs_logic_str,';']);
    xw = xw(ok);
    yw = yw(ok);
    if numel(xw)>=3
        k = convhull(xw,yw);
        xw = xw(k);
        yw = yw(k);
    else
        xw = [];
        yw = [];
    end
    
    %Plot white area
    if ~isempty( xw )
        p = patch( xw, yw,[1,1,1]);
        set(p,'EdgeColor','none');
    end
    
    %Add grid and axes box
    grid on
    box on
    set(ax,'layer','top')
    
    %Plot boundary curves
    for n=1:length(ineqs)
        if solid_line(n) == 1
            plot( xx{n},yy{n},'r-' );
        else
            plot( xx{n},yy{n},'r--');
        end
    end
    
    %Obtain colormap and its size
    cmap = colormap;
    Nc = size(cmap);
    Nc = Nc(1);
    
    %Plot allowed x,y values, colour coded via value of F
    if ( numel(x) >= Pmax )
        %Plot coloured surface
        xs = linspace(d.xmin,d.xmax,N);
        ys = linspace(d.ymin,d.ymax,N);
        [xs,ys] = meshgrid(xs,ys);
        ineqs_logic_str = strrep( ineqs_logic_str,'xw','xs' );
        ineqs_logic_str = strrep( ineqs_logic_str,'yw','ys' );
        eval( ['ok = ',ineqs_logic_str,';']);
        xyf = strrep( xyf,'x','xs' );
        xyf = strrep( xyf,'y','ys' );
        eval( ['FF=',xyf,';'] );
        FF(ok==0) = NaN;
        surf( xs, ys, FF );
        shading interp
        interp_colormap(N);
        warning off
        clear FF xs ys
    else
        %Plot points at valid integer values, coloured by F
        for n=1:numel(x)
            if ~isnan(x(n))
                if maxF==minF
                    normF = 1;
                else
                    normF = (F(n) - minF)/( maxF - minF );
                end
                red = interp1( linspace(0,1,Nc),cmap(:,1).' ,normF );
                green = interp1( linspace(0,1,Nc),cmap(:,2).' ,normF );
                blue = interp1( linspace(0,1,Nc),cmap(:,3).' ,normF );
                plot(x(n),y(n),'+','color',[red,green,blue]);
                plot(x(n),y(n),'o','color',[red,green,blue]);
            end
        end
    end
    
    %Plot minimum and maximum values as solid colours
    for m=1:length(imin)
        n = imin(m);
        if ~isnan(x(n))
            if maxF==minF
                normF = 1;
            else
                normF = (F(n) - minF)/( maxF - minF );
            end
            red = interp1( linspace(0,1,Nc),cmap(:,1).' ,normF );
            green = interp1( linspace(0,1,Nc),cmap(:,2).' ,normF );
            blue = interp1( linspace(0,1,Nc),cmap(:,3).' ,normF );
            plot(x(n),y(n),'o','markerfacecolor',[red,green,blue],...
                'markeredgecolor',[red,green,blue]);
        end
    end
    for m=1:length(imax)
        n = imax(m);
        if ~isnan(x(n))
            if maxF==minF
                normF = 1;
            else
                normF = (F(n) - minF)/( maxF - minF );
            end
            red = interp1( linspace(0,1,Nc),cmap(:,1).' ,normF );
            green = interp1( linspace(0,1,Nc),cmap(:,2).' ,normF );
            blue = interp1( linspace(0,1,Nc),cmap(:,3).' ,normF );
            plot(x(n),y(n),'o','markerfacecolor',[red,green,blue],...
                'markeredgecolor',[red,green,blue]);
        end
    end
    
    %Plot x and y axis
    plot( [0,0],[d.ymin,d.ymax],'k-','linewidth',2 );
    plot( [d.xmin,d.xmax],[0,0],'k-','linewidth',2 );
    
    %Determine title string
    if ~isempty(xmin)
        title_str = ['F = ',d.xyfunc,'. minF = ',num2str(minF),' at (',num2str(xmin(1)),...
            ',',num2str(ymin(1)),'), maxF = ',num2str(maxF),' at (',num2str(xmax(1)),',',num2str(ymax(1)),')'];
    else
        title_str = ['F = ',d.xyfunc,'. No (x,y) values satisfy all the inequalities'];
    end
    title(title_str,'fontsize',fsize);
    
    %Set equi-spaced grid and fix limits
    if d.xyscale==1
        axis equal
    else
        axis normal
    end
    set(ax,'fontsize',fsize);
    xlim( [d.xmin,d.xmax] );
    ylim( [d.ymin,d.ymax] );
    xlabel('x','fontsize',fsize)
    ylabel('y','fontsize',fsize)
    
    %Determine tick marks for grid
    yticks = roundn(d.ymin,1) : roundn(d.ytick,1) : roundn(d.ymax,1);
    xticks = roundn(d.xmin,1) : roundn(d.xtick,1) : roundn(d.xmax,1);
    set( ax, 'xtick',xticks,'ytick',yticks );
    grid on;
    
    %Add a colorbar if there are any valid (x,y) points that satisfy all inequalities.
    %Strangley the font size appears to be scaled, hence manual 0.6 factor
    if ( ~isempty(xmin) ) && (minF ~= maxF )
        d.colorbar = colorbar;
        if ax==d.h.AXESgraph
            set(d.colorbar,'fontsize',fsize*0.6);
        end
    else
        d.colorbar = [];
    end
else
    %Empty grid. Use this for creating graph paper, so plot solid lines
    %rather than use the conventional grid
    cla;
    title('');
    set(ax,'fontsize',fsize);
    axis manual;
    
    %Set equi-spaced grid and fix limits
    if d.xyscale==1
        axis equal
    else
        axis normal
    end
    xlim( [d.xmin,d.xmax] );
    ylim( [d.ymin,d.ymax] );
    xlabel('x','fontsize',fsize)
    ylabel('y','fontsize',fsize)
    yticks = roundn(d.ymin,1) : roundn(d.ytick,1) : roundn(d.ymax,1);
    xticks = roundn(d.xmin,1) : roundn(d.xtick,1) : roundn(d.xmax,1);
    set( ax, 'xtick',xticks,'ytick',yticks );
    hold on;
    
    %Vertical lines
    x = floor(d.xmin) : ceil(d.xmax);
    for n=1:length(x)
        plot( [x(n),x(n)],[d.ymin,d.ymax], 'k-' );
    end
    
    %Horizontal lines
    y = floor(d.ymin) : ceil(d.ymax);
    for n=1:length(y)
        plot( [d.xmin,d.xmax], [y(n),y(n)], 'k-' );
    end
    
    %Add box around axis
    box on
end

%%

%Round to n decimal places
function x = roundn(x,n)
x = x*10^n;
x = round(x);
x = x*10^-n;

%%

%Set values to be NaN if imaginary parts detected
function y = imag_check(x)
im_tol = 1e-6;
ok = find( ( abs( imag(x) ) < im_tol ) );
y = NaN(size(x));
y(ok) = real( x(ok) );

%%

% Return vectors of boundary lines given an
% inequality string ineqs e.g. s = '3*x-4*y >=10'
% solid_line = 1 when we have an equals sign.
function [x_boundary,y_boundary,solid_line] = boundaries( s,xmin,xmax,ymin,ymax,N)

%Check string s for blank inputs, or constant inputs.
if isempty(s)==1
    x_boundary = [];
    y_boundary = [];
    solid_line = 0;
else
    
    %Determine whether boundary line is solid or not
    if ~isempty( strfind( s,'>=' ) )
        solid_line = 1;
    elseif ~isempty( strfind( s,'<=' ) )
        solid_line = 1;
    elseif ~isempty( strfind( s,'=' ) )
        solid_line = 1;
    else
        solid_line = 0;
    end
    
    %Recast inequality s for use for boundary calculation
    s = strrep(s,'>=','=');
    s = strrep(s,'<=','=');
    s = strrep(s,'>','=');
    s = strrep(s,'<','=');
    
    %Determine boundary lines
    x_boundary = linspace(xmin,xmax,N);
    [x_boundary, y_boundary] = implicit( x_boundary, s, xmin,xmax,ymin,ymax );
end

%%

%implicit
% Function which evaluates (approximately) the y values whch solve the equation
% (in terms of variables x,y) describes by string fxy_str, given x values
% defined by the input to the function. The function returns the y value
% which closest evaluates the function, within the range speciafied.
%
% LAST UPDATED by Andy French January 2016
%
% Syntax: [x,y] = implicit( x, fxy_str, xmin,xmax,ymin,ymax )
%
% Example: x = linspace( -pi,pi,100 ); fxy_str = 'sin(y)+cos(x)=1';
% ymin = -2; ymax = 2; xmin = -5; xmax = 5; [x,y] = implicit( x, fxy_str, xmin,xmax,ymin, ymax );
% plot(x,y); xlabel('x'); ylabel('y'); title( fxy_str );

function [xx,yy] = implicit( x, fxy_str,xmin,xmax,ymin,ymax )

%%% Hard code number of y (or x) values to choose from %%%
N = 500;

%%

%Initialise outputs
yy = NaN(size(x));
xx = x;

%Check inputs make sense
if ( ymax <= ymin ) || (xmax <= xmin )
    return
end

%Obtain strings for functions f(x,y) and g(x,y) such that fxy_str is f(x,y) = g(x,y)
equals_str = strfind(fxy_str,'=');
f = fxy_str(1:equals_str-1);
g = fxy_str(equals_str+1:end);

%f(x) = g(x) hence f(x) - g(x) = 0
if ( isempty( strfind( fxy_str, 'y' )) == 1 )
    
    %Evaluate h = f-g and find x such that h = 0 in the desired range
    x = linspace(xmin,xmax,N);
    eval( ['h = ',f,'-(',g,');'] );
    xroots = rootfinder( x,h );
    if ~isempty(xroots)
        %Choose the first root (i.e. ignore any multiple roots)
        xx = xroots(1)*ones(1,N);
        yy = linspace(ymin,ymax,N);
    end
    
    %f(y) = g(y) hence f(y) - g(y) = 0
elseif ( isempty( strfind( fxy_str, 'x' )) == 1 )
    
    %Evaluate h = f-g and find y such that h = 0 in the desired range
    y = linspace(ymin,ymax,N);
    eval( ['h = ',f,'-(',g,');'] );
    yroots = rootfinder( y,h );
    if ~isempty(yroots)
        %Choose the first root (i.e. ignore any multiple roots)
        yy = yroots(1)*ones(1,N);
        xx = linspace(xmin,xmax,N);
    end
    
    %f(x,y) = g(x,y)
else
    %Define vector of y values
    y = linspace(ymin,ymax,N);
    
    %Set tolerance for closeness of function match
    tol = 2*(ymax-ymin)/N;
    
    %Loop over x values and dtermine most appropriate y values
    for n=1:numel(xx)
        
        %Redefine x as a single number, for use in the evaluation of string
        %fxy_str
        x = xx(n);
        
        %Turn fxy_str f(x,y) = g(x,y) into an equation f the form
        % abs( f - g ) = 0. Find y valus which minimize abs( f - g )
        eval( ['h = abs(',f,'-(',g,'));'] );
        k = find( (h==min(h)) & (h<tol) );
        if isempty(k)
            yy(n) = NaN;
        else
            k = k(1);
            yy(n) = y(k);
        end
    end
    
    %Remove NaN elements and find the desired outputs via interpolation
    not_nan = ~isnan(yy);
    xx = xx(not_nan);
    yy = yy(not_nan);
end

%%

%rootfinder
% Function which approximates the roots of a function y(x) given a vector
% of x and y values
function xroots = rootfinder( x,y )

%Initialise output
xroots = [];

%Make sure x is in ascending order
[x,s] = sort(x);
y = y(s);

%Step through y and check for any axes crossings. Do this by looking for
%sign changes in y.
sgn = sign(y(1));
if length(x)>=1
    for n=2:length(x)
        if sign(y(n))~=sgn
            %Sign change! There is a root. Let is assume it is half way between
            %the x values.
            xroots = [xroots, (x(n-1) + x(n) )/2 ];
        end
        sgn = sign(y(n));
    end
end

%%

%figcenter
% Centres a figure with handle fig in the current display.
%
% LAST UPDATED by Andy French Feb 2015

function figcentre(fig)

%Get screen dimensions in pixels.
set(0,'units','pixels') ;
screen_size=get(0,'Screensize');
display_size=get(0,'MonitorPositions');

%Get original figure units
orig_units = get(fig,'units');

%Get position vector for figure in pixels
set(fig,'units','pixels');
fig_position=get(gcf,'position') ;

%Define coordinates or figure bottom hand corner from screen bottom hand corner
%that will place the figure window in the center of the screen.
centre_x = 0.5*( display_size(3)-fig_position(3) ) - screen_size(1);
centre_y = 0.5*( display_size(4)-fig_position(4) ) - screen_size(2);

%Modify figure position to centre
set(fig,'position',[centre_x,centre_y,fig_position(3),fig_position(4)] );

%Reset figure units
set(fig,'units',orig_units);

%%

%interp_colormap
% Function which interpolates current colourmap to yield better graduated
% shading. N is number of possible colours.
%
% LAST UPDATED by Andy French 14 September 2008

function interp_colormap( N )

%Get current colourmap
map = colormap;

%Initialise new colormap
new_map = ones(N,3);

%Get size of current colormap and initalise red,green,blue vectors
dim = size(map);
R = ones(1,dim(1));
G = ones(1,dim(1));
B = ones(1,dim(1));
RR = ones(1,N);
GG = ones(1,N);
BB = ones(1,N);

%Populate these with current colormap
R(:) = map(:,1);
G(:) = map(:,2);
B(:) = map(:,3);

%Interpolate to yield new colour map
x = linspace( 1, dim(1), N );
RR = interp1( 1:dim(1), R, x );
GG = interp1( 1:dim(1), G, x );
BB = interp1( 1:dim(1), B, x );
new_map(:,1) = RR(:);
new_map(:,2) = GG(:);
new_map(:,3) = BB(:);

%Set colormap to be new map
colormap( new_map );

%End of code

